std::experimental::_Optional_base< _Tp, _ShouldProvideDestructor >(3)

NAME
std::experimental::_Optional_base< _Tp, _ShouldProvideDestructor > - Class template that holds the necessary state for Optional values and that has the responsibility for construction and the special members.

SYNOPSIS

  Public Member Functions
constexpr _Optional_base (nullopt_t) noexcept
template<typename... _Args> constexpr _Optional_base (in_place_t, _Args &&... __args)
template<typename _Up , typename... _Args, enable_if_t< is_constructible< _Tp, initializer_list< _Up > &, _Args &&... >::value, int > ...> constexpr _Optional_base (in_place_t, initializer_list< _Up > __il, _Args &&... __args)
_Optional_base (const _Optional_base &__other)
_Optional_base (_Optional_base &&__other) noexcept(is_nothrow_move_constructible< _Tp >())
_Optional_base & operator= (const _Optional_base &__other)
_Optional_base & operator= (_Optional_base &&__other) noexcept(__and_< is_nothrow_move_constructible< _Tp >, is_nothrow_move_assignable< _Tp >>())

  Protected Member Functions
template<typename... _Args> void _M_construct (_Args &&... __args) noexcept(is_nothrow_constructible< _Stored_type, _Args... >())
void _M_destruct ()
constexpr _Tp & _M_get () noexcept
constexpr const _Tp & _M_get () const noexcept
constexpr bool _M_is_engaged () const noexcept
void _M_reset ()

Detailed Description

  template<typename _Tp, bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>
class std::experimental::_Optional_base< _Tp, _ShouldProvideDestructor >" Class template that holds the necessary state for Optional values and that has the responsibility for construction and the special members. Such a separate base class template is necessary in order to conditionally enable the special members (e.g. copy/move constructors). Note that this means that _Optional_base implements the functionality for copy and move assignment, but not for converting assignment.

See also:
    optional, _Enable_special_members

Definition at line 202 of file optional.

Author

Generated automatically by Doxygen for libstdc++ from the source code.